routes/web.php
<?php

use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Auth::routes();

Route::get('/', function () {
    return redirect('login');
});

Route::group(['middleware' => 'auth', 'namespace' => 'Admin'], function () {
    Route::get('/dashboard', 'DashboardController@index')->name('dashboard');
    Route::get('/profile/me', 'UserController@profile')->name('users.profile');
    Route::get('/request-absent/{request_absent}/approve', 'RequestAbsentController@approve')->name('request-absent.approve');
    Route::post('/request-absent/approve-or-reject', 'RequestAbsentController@approveOrRejectAll')->name('request-absent.approve-or-reject');
    Route::get('/overtimes/{overtime}/approve', 'OvertimeController@approve')->name('overtimes.approve');
    Route::post('/overtime/approve-or-reject', 'OvertimeController@approveOrRejectAll')->name('overtime.approve-or-reject');
    Route::resource('/users', 'UserController');
    Route::resource('/request-absent', 'RequestAbsentController');
    Route::resource('/overtimes', 'OvertimeController');
    Route::resource('/config', 'ConfigController')->middleware('admin');
    Route::resource('/notification', 'NotificationController')->middleware('admin');
    Route::resource('/roles', 'RoleController')->middleware('admin');
    Route::resource('/work-titles', 'WorkTitleController')->middleware('admin');
    Route::get('/timesheets', 'DashboardController@index');
    Route::get('/logout', 'AuthController@logout');
    Route::get('/password/change', 'AuthController@changePasswordEdit')->name('change-password.edit');
    Route::put('/password/change', 'AuthController@changePasswordUpdate')->name('change-password.update');
    Route::get('timesheet/getData', '\App\Http\Controllers\Admin\TimeSheetController@getData')->name('timesheet.getData');
    Route::resource('national-day', '\App\Http\Controllers\Admin\NationalDayController')->middleware('admin');
    Route::resource('timesheet', '\App\Http\Controllers\Admin\TimeSheetController')->except(['show']);
    Route::resource('comments', '\App\Http\Controllers\Admin\CommentController');
    Route::put('timesheet/update-paid-leave/{id}', '\App\Http\Controllers\Admin\TimeSheetController@updatePaidLeave')
            ->name('timesheet.updatePaidLeave');
    Route::post('timesheet/upload-timesheet', '\App\Http\Controllers\Admin\TimeSheetController@uploadTimesheet')
            ->name('timesheet.uploadTimesheet')
            ->middleware('can:timesheet.uploadTimesheet');
    Route::get('timesheet/export-timesheet', '\App\Http\Controllers\Admin\TimeSheetController@ExportTimesheet')
            ->name('timesheet.exportTimesheet');
    Route::get('timesheet/create', '\App\Http\Controllers\Admin\TimeSheetController@create')
        ->name('timesheet.create')->middleware('can:timesheet.create');
    Route::get('timesheet/edit/{timesheet}', '\App\Http\Controllers\Admin\TimeSheetController@edit')
        ->name('timesheet.edit')->middleware('can:timesheet.update');
    Route::delete('timesheet/destroy/{timesheet}', '\App\Http\Controllers\Admin\TimeSheetController@destroy')
        ->name('timesheet.destroy')->middleware('can:timesheet.delete');
    Route::resource('/position', 'PositionController')->middleware('admin');
    Route::post('timesheet/update-all-month', '\App\Http\Controllers\Admin\TimeSheetController@updateMonthAll')
            ->name('timesheet.updateMonthAll')->middleware('admin');
    Route::post('users/upload-users', '\App\Http\Controllers\Admin\UserController@uploadUsers')
            ->name('users.uploadUsers')
            ->middleware('admin');
    Route::get('request-absents/export', '\App\Http\Controllers\Admin\RequestAbsentController@exportRequestAbsent')
            ->name('request-absent.exportRequestAbsent');
    Route::get('overtime/export', '\App\Http\Controllers\Admin\OvertimeController@exportOvertime')
            ->name('overtime.exportOvertime');
});

app/Models/NationalDay.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Support\Carbon;

class NationalDay extends Model
{
    protected $table = 'national_day';

    protected $fillable = [
        'name', 'from_date', 'to_date'
    ];

    /**
     * Get list national day
     * @param array $condition
     * @param null $perPage
     * @return \Illuminate\Database\Eloquent\Builder[]|\Illuminate\Database\Eloquent\Collection
     */
    public static function getListNationalDay($condition = [], $perPage = null)
    {
        $query = NationalDay::query();
        if (isset($condition['name'])){
            $query->where('name', 'like', '%'.$condition['name'].'%');
        }
        if (isset($condition['start_date']) && !empty($condition['start_date'])){
            $query->where('from_date', '>=', $condition['start_date']);
        }
        if (isset($condition['end_date']) && !empty($condition['end_date'])){
            $query->where('to_date', '<=', $condition['end_date']);
        }
        if (isset($condition['month']) && !empty($condition['month'])) {
            $query->where(function ($query) use ($condition) {
                $query->whereMonth('from_date', '=', $condition['month'])
                      ->orWhereMonth('to_date', '=', $condition['month']);
            });
        }
        if (isset($condition['year']) && !empty($condition['year'])) {
            $query->where(function ($query) use ($condition) {
                $query->whereYear('from_date', '=', $condition['year'])
                      ->orwhereYear('to_date', '=', $condition['year']);
            });
        }
        $query->orderBy('from_date', 'desc');
        if (!is_null($perPage)){
            return $query->paginate($perPage);
        }

        return $query->get();
    }

    /**
     * Check holiday
     * @param $day
     * @param $holiday
     */
    public static function holiday($day, $holiday)
    {
        $check = $holiday->where('from_date', '<=', Carbon::make($day)->format('Y-m-d'))
                ->where('to_date', '>=', Carbon::make($day)->format('Y-m-d'));
        return !$check->isEmpty();
    }

    /**
     * Check holiday
     * @param $day
     * @param $holiday
     */
    public static function countHolidayByMonth($month, $year)
    {
        $condition = [
            'month' => $month,
            'year' => $year
        ];
        $holidays = (new NationalDay())->getListNationalDay($condition);

        $total = 0;
        foreach ($holidays as $holiday) {
            $fromDate = Carbon::parse($holiday->from_date);
            $toDate = Carbon::parse($holiday->to_date);
            if($fromDate <= $toDate) {
                $total ++ ;
            }

            $total += $fromDate->diffInDays($toDate);
        }

        return $total;
    }

}

app/Http/Controllers/Admin/NationalDayController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Http\Requests\NationalDayRequest;
use App\Models\NationalDay;
use App\Models\PaidLeave;
use Carbon\Carbon;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Log;
use Yajra\DataTables\DataTables;

class NationalDayController extends Controller
{
    protected $nationalDayModel;
    public function __construct(NationalDay $nationalDay)
    {
        $this->nationalDayModel = $nationalDay;
    }

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Contracts\Foundation\Application|\Illuminate\Contracts\View\Factory|\Illuminate\Contracts\View\View
     */
    public function index(Request $request)
    {
        $params = $request->only('name');
        $page_title = __('layouts.national_holiday');
        $nationalDays = $this->nationalDayModel->getListNationalDay($params, 10);
        return view('national_day.index', compact('page_title', 'nationalDays'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Contracts\Foundation\Application|\Illuminate\Contracts\View\Factory|\Illuminate\Contracts\View\View
     */
    public function create()
    {
        $page_title = __('layouts.create_national_holiday');
        return view('national_day.create', compact('page_title'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\RedirectResponse
     */
    public function store(NationalDayRequest $request)
    {
        $input = $request->only(['name', 'from_date', 'to_date']);
        try {
            $nationalDay = $this->nationalDayModel->fill($input);
            $nationalDay->save();
            $this->updatePaidLeaveAllUser($input['from_date'], $input['to_date']);
            return redirect()->route('national-day.index')
                ->with([
                    'success' => true,
                    'message' => __('messages.create.success')
                ]);
        } catch (\Exception $exception){
            Log::error('Create national day: '. $exception->getMessage());
            return redirect()->route('national-day.index')
                ->with([
                    'success' => false,
                    'message' => __('messages.create.error')
                ]);
        }

    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param NationalDay $nationalDay
     * @return \Illuminate\Contracts\Foundation\Application|\Illuminate\Contracts\View\Factory|\Illuminate\Contracts\View\View
     */
    public function edit(NationalDay $nationalDay)
    {
        $page_title = __('layouts.edit_national_holiday');
        return view('national_day.edit', compact('page_title', 'nationalDay'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param NationalDayRequest $request
     * @param NationalDay $nationalDay
     * @return \Illuminate\Http\RedirectResponse
     */
    public function update(NationalDayRequest $request, NationalDay $nationalDay)
    {
        $input = $request->only(['name', 'from_date', 'to_date']);
        try {
            $nationalDay->fill($input);
            $nationalDay->save();
            $this->updatePaidLeaveAllUser($input['from_date'], $input['to_date']);
            return redirect()->route('national-day.index')->with([
                'success' => true,
                'message' => __('messages.edit.success')
            ]);
        }catch (\Exception $exception){
            Log::error('Edit national day: '. $exception->getMessage());
            return redirect()->route('national-day.index')->with([
                'success' => false,
                'message' => __('messages.edit.error')
            ]);
        }
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\RedirectResponse
     */
    public function destroy(NationalDay $nationalDay)
    {
        try {
            $from = $nationalDay->from_date;
            $to = $nationalDay->to_date;
            $nationalDay->delete();
            $this->updatePaidLeaveAllUser($from, $to);
            return redirect()->route('national-day.index')->with([
                'success' => true,
                'message' => __('messages.delete.success')
            ]);
        } catch (\Exception $exception){
            Log::error('Delete national day: '. $exception->getMessage());
            return redirect()->route('national-day.index')->with([
                'success' => false,
                'message' => __('messages.delete.error')
            ]);
        }

    }

    private function updatePaidLeaveAllUser($from, $to)
    {
        PaidLeave::createOrUpdateAllUserByMonth(Carbon::make($from)->format('Y-m'));
        if (Carbon::make($from)->format('Y-m') != Carbon::make($to)->format('Y-m')){
            PaidLeave::createOrUpdateAllUserByMonth(Carbon::make($to)->format('Y-m'));
        }

        return 1;
    }
}

resources/views/national_day/create.blade.php
@extends('layouts.app')

@section('style')
    <link href="{{ asset('css/daterangepicker.css') }}" rel="stylesheet">
@endsection
@section('content')
    <div class="container-fluid pb-3">
        @include('layouts.alert')
        <div class="card p-3 mb-3 rounded">
            <form action="{{ route('national-day.store') }}" method="POST">
                @csrf
                <div class="form-group row">
                    <label for="inputName" class="col-sm-2 col-form-label">{{ __('layouts.name') }}
                        <code>*</code>
                    </label>
                    <div class="col-sm-10 input-group">
                        <input class="form-control @error('name') is-invalid @enderror" type="text" name="name"
                               value="{{ old('name') }}" id="inputName">
                        @error('name')
                        <div class="invalid-feedback">{{ $message }}</div>
                        @enderror
                    </div>
                </div>
                <div class="form-group row">
                    <label for="inputFromTime" class="col-sm-2 col-form-label">{{ __('layouts.start_date') }}
                        <code>*</code>
                    </label>
                    <div class="col-sm-10 input-group">
                        <div class="input-group-prepend">
                            <span class="input-group-text">
                                <i class="far fa-calendar-alt"></i>
                            </span>
                        </div>
                        <input class="form-control date @error('from_date') is-invalid @enderror" type="text" id="inputFromTime"
                               placeholder="yyyy/mm/dd" name="from_date" value="{{ old('from_date') }}" autocomplete="off">
                        @error('from_date')
                        <div class="invalid-feedback">{{ $message }}</div>
                        @enderror
                    </div>
                </div>
                <div class="form-group row">
                    <label for="inputEndTime" class="col-sm-2 col-form-label">{{ __('layouts.end_date') }}
                        <code>*</code>
                    </label>
                    <div class="col-sm-10 input-group">
                        <div class="input-group-prepend">
                            <span class="input-group-text">
                                <i class="far fa-calendar-alt"></i>
                            </span>
                        </div>
                        <input class="form-control date @error('to_date') is-invalid @enderror" type="text" id="inputEndTime"
                               placeholder="yyyy/mm/dd" name="to_date" value="{{ old('to_date') }}" autocomplete="off">
                        @error('to_date')
                        <div class="invalid-feedback">{{ $message }}</div>
                        @enderror
                    </div>
                </div>
                <div class="d-flex justify-content-end mb-2">
                    <input class="btn btn-primary btn-width-default" type="submit" value="{{ __('layouts.create') }}">
                    <a class="btn btn-dark btn-width-default ml-2" href="{{ route('national-day.index') }}">{{ __('layouts.close') }}</a>
                </div>
            </form>
        </div>
    </div>
@endsection

resources/views/national_day/edit.blade.php
@extends('layouts.app')

@section('style')
    <link href="{{ asset('css/daterangepicker.css') }}" rel="stylesheet">
@endsection
@section('content')
    <div class="container-fluid pb-3">
        @include('layouts.alert')
        <div class="card p-3 mb-3 rounded">
            <form action="{{ route('national-day.update', $nationalDay->id) }}" method="POST">
                @csrf
                @method('PUT')
                <div class="form-group row">
                    <label for="inputName" class="col-sm-2 col-form-label">{{ __('layouts.name') }}
                        <code>*</code>
                    </label>
                    <div class="col-sm-10 input-group">
                        <input class="form-control @error('name') is-invalid @enderror" type="text" name="name"
                               value="{{ old('name', $nationalDay->name) }}" id="inputName">
                        @error('name')
                        <div class="invalid-feedback">{{ $message }}</div>
                        @enderror
                    </div>
                </div>
                <div class="form-group row">
                    <label for="inputFromTime" class="col-sm-2 col-form-label">{{ __('layouts.start_date') }}
                        <code>*</code>
                    </label>
                    <div class="col-sm-10 input-group">
                        <div class="input-group-prepend">
                            <span class="input-group-text">
                                <i class="far fa-calendar-alt"></i>
                            </span>
                        </div>
                        <input class="form-control date @error('from_date') is-invalid @enderror" type="text" id="inputFromTime"
                               placeholder="yyyy/mm/dd" name="from_date" value="{{ old('from_date', $nationalDay->from_date) }}" autocomplete="off">
                        @error('from_date')
                        <div class="invalid-feedback">{{ $message }}</div>
                        @enderror
                    </div>
                </div>
                <div class="form-group row">
                    <label for="inputEndTime" class="col-sm-2 col-form-label">{{ __('layouts.end_date') }}
                        <code>*</code>
                    </label>
                    <div class="col-sm-10 input-group">
                        <div class="input-group-prepend">
                            <span class="input-group-text">
                                <i class="far fa-calendar-alt"></i>
                            </span>
                        </div>
                        <input class="form-control date @error('to_date') is-invalid @enderror" type="text" id="inputEndTime"
                               placeholder="yyyy/mm/dd" name="to_date" value="{{ old('to_date', $nationalDay->to_date) }}" autocomplete="off">
                        @error('to_date')
                        <div class="invalid-feedback">{{ $message }}</div>
                        @enderror
                    </div>
                </div>

                <div class="d-flex justify-content-end mb-2">
                    <input class="btn btn-primary btn-width-default" type="submit" value="{{ __('layouts.save') }}">
                    <a class="btn btn-dark ml-2 btn-width-default" href="{{ route('national-day.index') }}">{{ __('layouts.close') }}</a>
                </div>
            </form>
        </div>
    </div>
@endsection

resources/views/national_day/index.blade.php
@extends('layouts.app')

@section('style')
    <link href="{{ asset("css/dataTables.bootstrap4.min.css") }}" rel="stylesheet" type="text/css">
    <link href="{{ asset('css/daterangepicker.css') }}" rel="stylesheet">
@endsection
@section('content')
    <div class="container-fluid pb-3">
        <div class="card p-3 rounded-lg">
            <div class="row">
                <div class="col-md-8">
                    <a class="btn btn-primary text-nowrap btn-width-default" href="{{ route('national-day.create') }}">{{ __('layouts.add') }}</a>
                </div>
{{--                <div class="col-md-4">--}}
{{--                    <form class="form-inline my-lg-0 justify-content-end" method="GET" action="{{ route('users.index') }}">--}}
{{--                        <input class="form-control mr-sm-2 mt-2" type="search" placeholder="{{ __('layouts.user_search_key') }}" aria-label="Search" name="search" value="{{ $search }}">--}}
{{--                        <button class="btn btn-dark mt-2 btn-width-default" type="submit">{{ __('layouts.search') }}</button>--}}
{{--                    </form>--}}
{{--                </div>--}}
            </div>
            @include('layouts.alert')
            <div class="table-responsive">
                <table class="table table-striped my-3 table-borderless table-striped-reverse">
                    <thead class="thead-dark">
                    <tr>
                        <th>#</th>
                        <th>{{ __('layouts.name') }}</th>
                        <th>{{ __('layouts.start_date') }}</th>
                        <th>{{ __('layouts.end_date') }}</th>
                        <th></th>
                    </tr>
                    </thead>
                    <tbody>
                    @if (count($nationalDays) == 0)
                        <tr>
                            <td class="text-danger no-data" colspan="8">{{ __('messages.no_data') }}</td>
                        </tr>
                    @endif
                    @foreach ($nationalDays as $nationalDay)
                        <tr>
                            <td>{{ ($nationalDays->currentPage() - 1) * $nationalDays->perPage() + $loop->iteration }}</td>
                            <td>{{ $nationalDay->name }}</td>
                            <td>{{ $nationalDay->from_date }}</td>
                            <td>{{ $nationalDay->to_date }}</td>
                            <td>
                                <div class="d-flex justify-content-right">
{{--                                    <a class="btn btn-success py-0 px-1" href="{{ route('national-day.show', $nationalDay->id) }}" data-toggle="tooltip" title="{{ __('layouts.show') }}"><i class="fas fa-eye"></i></a>--}}
                                    @roles('admin')
                                    <a class="btn btn-primary py-0 px-1 mx-2" href="{{ route('national-day.edit', $nationalDay->id) }}" data-toggle="tooltip" title="{{ __('layouts.edit') }}"><i class="fas fa-pen"></i></a>
                                    <form class="inline-block" method="POST" action="{{ route('national-day.destroy', $nationalDay->id) }}">
                                        <input type="hidden" name="_method" value="DELETE">
                                        <input type="hidden" name="_token" value="{{ csrf_token() }}" />
                                        <button class="btn btn-danger py-0 px-1 delete" data-toggle="tooltip" title="{{ __('layouts.delete') }}">
                                            <i class="fas fa-trash-alt"></i>
                                        </button>
                                    </form>
                                    @endroles
                                </div>
                            </td>
                        </tr>
                    @endforeach
                    </tbody>
                </table>
            </div>
            @include('layouts.paginate', ['paginate' => $nationalDays])
        </div>
    </div>
@endsection

@section('script')
    <script src="{{ asset("js/jquery.dataTables.min.js") }}" defer ></script>
    <script src="{{ asset('js/moment.min.js') }}"></script>
    <script src="{{ asset('js/daterangepicker.js') }}"></script>
@endsection